<?xml version="1.0" encoding="utf-8"?>
<Config>
    <Global>
        <FrontCamera>0</FrontCamera> <!-- 前置开关，前置设1，后置设0 -->
        <HDCCalibW>3968</HDCCalibW> <!-- v600字节标定没有存分辨率，需要指定 -->
        <HDCCalibH>2976</HDCCalibH>
        <MainCameraID1>2</MainCameraID1> <!-- 双目第一组模组送显对应的cameraID-->
        <cameraID1Setting>0</cameraID1Setting> <!-- 双目第一组模是否有setting-->
        <MainCameraID2>8</MainCameraID2> <!-- 双目第二组模组送显对应的cameraID-->
        <cameraID2Setting>0</cameraID2Setting> <!-- 双目第二组模是否有setting-->
        <CameraID2FocalLengthFactor>2</CameraID2FocalLengthFactor> <!-- 视差转深度 fb 需要除以该系数(tele 镜头) 得到相对深度-->
        <EnableDualRectification>1</EnableDualRectification> <!-- 双摄斜放适配标志位-->
        <EnableDualDisparity>1</EnableDualDisparity> <!-- 倾斜视差适配标志位-->
        <EnableCameraID2Modify>0</EnableCameraID2Modify> <!-- 第二组模组ID是否需要修改标志位-->
        <BypassCameraIDCheck>1</BypassCameraIDCheck> <!-- 是否跳过CameraID检查标志位-->
        <SubCameraZoomRatio>1.17</SubCameraZoomRatio> <!-- 第二组模组ID是否需要修改标志位-->
    </Global>

    <AlgorithmPreprocessInfo>
        <distortionAlg enable="1">
            <brownEnable>1</brownEnable>        <!-- 0: disable 1: enable -->
            <bsplineEnable>1</bsplineEnable>    <!-- 0: disable 1: enable -->
        </distortionAlg>
        <stereoConsistentTh>1.0</stereoConsistentTh> <!-- 主副图一致性检测阈值，越大要求越低 -->
        <rectifyErrorSigamScale>3</rectifyErrorSigamScale> <!-- 矫正失败虚化强度减弱系数，除以这个数 -->
        <OTPRectifyEnable>1</OTPRectifyEnable>     <!-- 0: disable 1: enable -->
        <subLargeFovCropEnable>1</subLargeFovCropEnable>
        <selfLearnAlg enable="1">           <!-- 0: disable 1: enable -->
            <fpThresLeft>1000</fpThresLeft> <!-- 特征点检测阈值，越小点越多 -->
            <fpThresRight>800</fpThresRight>
            <doubleRansac>1</doubleRansac>
        </selfLearnAlg>

        <brightnessColorAdjustEnable>0</brightnessColorAdjustEnable>
        <brightnessGrayAdajustEnable>0</brightnessGrayAdajustEnable>
        <onlineDistortionEnable>0</onlineDistortionEnable>
        <preResize>1</preResize>
        <refImgBlur>1</refImgBlur>
        <matImgBlur>0</matImgBlur>
        <oisWarpEnable>1</oisWarpEnable>
        <rawImgEnable>1</rawImgEnable> <!-- 使用raw图优化效果 -->
        <useGuideImgStereoMatch>1</useGuideImgStereoMatch> <!-- 使用guide图算深度 -->
        <checkGuideRefRatio>1</checkGuideRefRatio> <!-- 检查ref图裁剪宽高比是否与guide图对齐 -->
        <guideImgEnable>0</guideImgEnable> <!-- 使用guide图优化效果 -->
        <teleOffset>10.0</teleOffset> <!-- 长焦焦段负视差补偿值 -->
    </AlgorithmPreprocessInfo>

    <AlgorithmPreView>
        <dispOffset>12.0</dispOffset>
        <dispOffsetTele>4.0</dispOffsetTele>
        <lastHWeight>0.75</lastHWeight> <!-- range 0-1 -->
        <OrbWarpBindBigCoreEnable>0</OrbWarpBindBigCoreEnable>
        <OrbWarpEnable>1</OrbWarpEnable>
        <teleMatResizeScaleX>1.0</teleMatResizeScaleX>
        <teleMatResizeScaleY>0.99</teleMatResizeScaleY>
    </AlgorithmPreView>

    <AlgorithmDCInfo>
        <TwoPlaneAlgCfg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>704</modelWidth>
            <modelHeight>704</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/PCTClas_withaug_5w.om</modelPath>
            <isSoftmax>1</isSoftmax>
            <normData>0</normData>
        </TwoPlaneAlgCfg>

        <mattingAlg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>640</modelWidth>
            <modelHeight>640</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/matting.ms</modelPath>
            <isSoftmax>0</isSoftmax>
            <normData>2</normData>
        </mattingAlg>

        <dispNetCfg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>1024</modelWidth>
            <modelHeight>416</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/dispnet_dual.ms</modelPath>
            <normData>2</normData>
        </dispNetCfg>
        
        <vBinPdDepthcalcCfg enable="1">
        <!-- 0: disable 1: enable -->
            <modelWidth>512</modelWidth>
            <modelHeight>384</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/depth_vbin_384x512.ms</modelPath> <!-- mark 模型量化后进行修改 -->
            <normData>2</normData>        <!-- 0, 不归一化，1，只减均值， 2 减均值并除以255 -->
        </vBinPdDepthcalcCfg>
      
        <quadPdDepthcalcCfg enable="1">
            <!-- 0: disable 1: enable -->
            <modelWidth>496</modelWidth>
            <modelHeight>384</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/depth_quad_384x496.ms</modelPath> <!-- mark 模型量化后进行修改 -->
            <normData>2</normData>        <!-- 0, 不归一化，1，只减均值， 2 减均值并除以255 -->
        </quadPdDepthcalcCfg>

        <cpdDepthmapCfg enable="1">
            <!-- 0: disable 1: enable -->
            <fitAlpha>10</fitAlpha>
            <fitBeta>5</fitBeta>
            <fitAlphaVbin>7</fitAlphaVbin>
            <VbinRouterThreshold>50</VbinRouterThreshold>
            <QuadRouterThreshold>0.65f</QuadRouterThreshold>
            <quadAdaptAfDepth>500.f</quadAdaptAfDepth>
            <vbinAdaptAfDepthMax>350.f</vbinAdaptAfDepthMax>
            <vbinAdaptAfDepthMin>250.f</vbinAdaptAfDepthMin>
            <routerFaceGain>1.5f</routerFaceGain>
            <enableAfDepth>1</enableAfDepth>
            <enableQuad>1</enableQuad>
            <enableVbin>1</enableVbin>
        </cpdDepthmapCfg>

        <compensatorCfg enable="1">
            <!-- 0: disable 1: enable -->
            <quadSrcWidth>29</quadSrcWidth>
            <quadSrcHeight>29</quadSrcHeight>
            <quadGainW>68</quadGainW>
            <quadGainH>52</quadGainH>
            <baseImgMax>0.10781275</baseImgMax>
            <decayCoef>0.65</decayCoef>
            <vBinSrcWidth>16</vBinSrcWidth>
            <vBinSrcHeight>12</vBinSrcHeight>
            <vBinGain>58</vBinGain>
        </compensatorCfg>
        
        <sparseDispAlg enable="1">          <!-- 0: disable 1: enable -->
            <DCEAlg enable="1">
                <baseConfig>
                    <ratio>2</ratio>    <!-- {1, 2} output resolution width/ratio-->
                    <lrcheckEnable>0</lrcheckEnable>
                </baseConfig>
                <externConfig enable="0">
                    <lrcheckEnable> 0 </lrcheckEnable>
                </externConfig>
            </DCEAlg>
            <DMAPAlg enable="0">
                <dmapVersion>4</dmapVersion>     <!--0:v150, 1:v160, 2:v200, 3:v250, 4:v300... 15:unknown-->
                <baseConfig>
                    <lrcheckEnable>1</lrcheckEnable>
                </baseConfig>
                <externConfig enable="1">
                    <lrcheckEnable>0</lrcheckEnable>
                </externConfig>
            </DMAPAlg>

            <sparseOptAlg>
                <occOptEnable>0</occOptEnable>           <!-- 0: disable 1: enable -->
                <eyesOptEnable>1</eyesOptEnable>
                <blackFillEnable>0</blackFillEnable>    <!-- 0: disable 1: enable -->
                <skyOptEnable>0</skyOptEnable>          <!-- 0: disable 1: enable -->
                <subPixelsEnable>0</subPixelsEnable>    <!-- hl always close -->
                <portraitMaskOptInterEnable>1</portraitMaskOptInterEnable>
                <portraitMaskOptOuterEnable>0</portraitMaskOptOuterEnable>
                <portraitMaskOptHoleEnable>0</portraitMaskOptHoleEnable>
                <adpaptWithTofEnable>1</adpaptWithTofEnable>
                <fillWithSparseSegEnable>1</fillWithSparseSegEnable>
            </sparseOptAlg>
        </sparseDispAlg>

        <denseDispAlg>
            <opticalFlowAlg>
                <ratio>4</ratio>                  <!-- {1, 2, 4} output resolution width/ratio-->
                <occEnable>1</occEnable>            <!-- 0: disable 1: enable -->
                <headOptInterEnable>1</headOptInterEnable>    <!-- 0: disable 1: enable -->
                <headOptOuterEnable>0</headOptOuterEnable>    <!-- 0: disable 1: enable -->
            </opticalFlowAlg>

            <adaptureEnableHair>1</adaptureEnableHair>
            <adaptureEnableHairSuper>1</adaptureEnableHairSuper>

            <denseOptAlg>
                <fingerEnable>4</fingerEnable>            <!-- 0: disable 1 & other: Tradition, 2: Tradition & CNN, 3: CNN & Tradition, 4: CNN  -->
                <fingerSegType>0</fingerSegType>            <!-- 0: CNN Segment, 1: GMM   -->
                <fingerModelPath>/vendor/etc/camera/cnnmodel/dualcamera/DualCamera_BC_HandDetect.om</fingerModelPath>
                <fingerSegModelWidth>224</fingerSegModelWidth>
                <fingerSegModelHeight>224</fingerSegModelHeight>
                <fingerSegModelPath>/vendor/etc/camera/cnnmodel/dualcamera/DualCamera_BC_FingerSeg.om</fingerSegModelPath>
                <fingerSegIsSoftmax>1</fingerSegIsSoftmax>
                <fingerSegNormData>0</fingerSegNormData>
                <deburrEnable>0</deburrEnable>            <!-- 0: disable 1: enable -->
                <tofFrontCamera>0</tofFrontCamera>        <!-- 0: tof is rear camera 1: tof is front camera-->
                <tofGuideEnable>0</tofGuideEnable>            <!-- 0: disable 1: enable -->
                <tofModifyEnable>0</tofModifyEnable>            <!-- 0: disable 1: enable -->
                <portraitPlaneEnable>1</portraitPlaneEnable>    <!-- 0: disable 1: enable -->
                <cropAdaptEnable>1</cropAdaptEnable>
                <twoPlaneMode>1</twoPlaneMode>                          <!-- cherry -- //1:对概率值双边二值化 0:对深度值双边 -->
                <numTwoPlaneHoleThres>10</numTwoPlaneHoleThres>          <!-- cherry场景镂空数阈值 -->
                <fewHoleFrontVariance>57</fewHoleFrontVariance>          <!-- cherry场景少镂空时前景方差阈值 -->
                <fewHoleBackVariance>50</fewHoleBackVariance>            <!-- cherry场景少镂空时后景方差阈值 -->
                <manyHoleFrontVariance>110</manyHoleFrontVariance>        <!-- cherry场景多镂空时前景方差阈值 -->
                <manyHoleBackVariance>80</manyHoleBackVariance>            <!-- cherry场景多镂空时前景方差阈值 -->
                <fewHoleNotPortraitValidRatio>40</fewHoleNotPortraitValidRatio>               <!-- cherry场景少镂空时非人像稠密度阈值 -->
                <manyHoleNotPortraitValidRatio>30</manyHoleNotPortraitValidRatio>               <!-- cherry场景多镂空时非人像稠密度阈值 -->
                <cherry_seg_switch>1</cherry_seg_switch>                   <!-- cherry场景多镂空时非人像稠密度阈值 -->
                <SuperPortraitSwitch>1</SuperPortraitSwitch>                   <!-- 超级人像开关 -->
                <railOptEnable>1</railOptEnable>    <!-- 0: disable 1: enable -->
            </denseOptAlg>
            <mattingWithCnnMask>1</mattingWithCnnMask>    <!-- matting分割是否使用人像分割结果作为输入 -->
            <hasMattingOutput>0</hasMattingOutput>    <!-- 是否输出matting 结果 -->
            <aiDepthSlice>2</aiDepthSlice>    <!-- aiDepth 切片数量：1：不切片，2：切片两次 -->
            <aiDepthUseSparse>0</aiDepthUseSparse>    <!-- 0: disable 1: 稀疏图在输入0位置 2：稀疏图在输入1位置 -->
            <invalidSparse>-0.1</invalidSparse>    <!-- 输入到aiDepth的稀疏图无效值 -->
            <sparseScale>4</sparseScale>    <!-- 输入到aiDepth的稀疏图scale值 -->
            <dispOutScale>128.0</dispOutScale>    <!-- aiDepth输出scale值 -->
        </denseDispAlg>
    </AlgorithmDCInfo>

    <AlgorithmRFInfo>
        <frontFilterEnable>1</frontFilterEnable>        <!-- IIR filter -->
        <edgeFilterEnable>1</edgeFilterEnable>          <!-- 0: disable 1: enable -->
        <blurEnhanceRatio>1.0</blurEnhanceRatio>                      <!--  [0.5, 2.0] -->
        <dofEnhanceRatio>1.0</dofEnhanceRatio>                       <!--  [0.5, 5.0] -->
        <spotTh>220</spotTh>                            <!--  [80, 255] -->
        <portraitBlurEnhanceRatio>1.0</portraitBlurEnhanceRatio>      <!--  [0.5, 2.0] -->
        <spotEnhanceEnable>0</spotEnhanceEnable>
        <srcWeightSwirlAndDiscsRatio>5</srcWeightSwirlAndDiscsRatio>
        <srcWeightHeartRatio>3</srcWeightHeartRatio>
        <portraitAutoAdjustFocusPointEnable>1</portraitAutoAdjustFocusPointEnable> <!--人像模式多人场景自动选择对焦人脸-->
        <noiseUniformEnable>1</noiseUniformEnable> <!--前后景噪声一致性-->
        <noiseUniformStrength>6</noiseUniformStrength> <!--噪声强度 [0, 10]-->
        <noiseUniformIsoTh>10</noiseUniformIsoTh> <!--iso阈值/10 [0, 255]-->
        <noiseWH>300</noiseWH>
        <noiseFile>/vendor/etc/camera/dcamera/noise.bin</noiseFile>
        <weightEnhanceCoefSpot>5</weightEnhanceCoefSpot> <!--光斑增强系数 [1, 30]-->
        <spotShapeAndContrastEnhanceEnable>1</spotShapeAndContrastEnhanceEnable> <!-- 0: disable 1: enable -->
        <dofAdaptiveNearFocusDistanceThr>6</dofAdaptiveNearFocusDistanceThr> <!--近距离阈值[0,255]分米-->
        <dofAdaptiveFarFocusDistanceThr>20</dofAdaptiveFarFocusDistanceThr> <!--远距离阈值[0,255]分米-->
        <dofAdaptiveNearDofRatioThr>15</dofAdaptiveNearDofRatioThr> <!--近距离dof值[5,50]/10-->
        <dofAdaptiveFarDofRatioThr>10</dofAdaptiveFarDofRatioThr> <!--远距离dof值[5,50]/10-->
        <circleFilterFlareDilateR>7</circleFilterFlareDilateR> <!--光斑检测的腐蚀半径[3-10]-->
        <farFocusBlurEnhanceEnable>0</farFocusBlurEnhanceEnable> <!--主体离得远时虚化增强使能-->
        <flaresColorOptCoef>25</flaresColorOptCoef> <!--光斑颜色饱和度系数[10~35]-->
        <flaresBrightnessCoef>18</flaresBrightnessCoef> <!--光斑亮度系数[1~25]-->
        <alphaEdgeSoftEnable>1</alphaEdgeSoftEnable> <!--alpha边缘平滑优化-->
        <portraitFrontBlurEnable>0</portraitFrontBlurEnable> <!--人像模式前景虚化使能-->
        <matteHairEnhanceDisable>1</matteHairEnhanceDisable> <!--matte导图发丝高频增强置零-->
        <flaresOptInDarkEnable>1</flaresOptInDarkEnable> <!--暗光场景光斑优化-->
        <bgAdaptEnhanceEnable>1</bgAdaptEnhanceEnable> <!--背景自适应虚化增强使能-->
        <realDofAdjustEnable>1</realDofAdjustEnable> <!--焦距缩放开启-->
        <circleBlurCheckEnable>1</circleBlurCheckEnable> <!--使用内聚式判断虚化-->
        <weightCoef>1</weightCoef>  <!--权重计算系数-->
        <refAFDisable>0</refAFDisable>  <!--对焦牵引关闭-->

        <!-- backgroupAdj-->
        <bgadj>
            <contractAdjustEnable> 0 </contractAdjustEnable> <!-- 0:disable, 1 enable -->
            <colorAdjustEnable> 0 </colorAdjustEnable> <!-- 0:disable, 1 enable -->
            <lumaAdjustEnable> 0 </lumaAdjustEnable> <!-- 0:disable, 1 enable -->
            <bfRadius> 32 </bfRadius> <!-- BoxFilter radius-->
            <contractParam> 5 </contractParam>  <!-- Range:[0, 20] -->
            <lumaAdjustGain> -5 </lumaAdjustGain> <!-- Range:[-20, 20] -->
            <colorAdjRatio> 1.2 </colorAdjRatio> <!-- Range:[0.8f, 1.6f] -->
        </bgadj>

        <matButiAlg enable="1">     <!-- 0: disable 1: enable -->
            <modelWidth>768</modelWidth>
            <modelHeight>768</modelHeight>
            <modelPath>/vendor/etc/camera/cnnmodel/dualcamera/perfectBokehInterp.ms</modelPath>
            <isSoftmax>1</isSoftmax>
            <normData>2</normData>
            <useGPU>0</useGPU>
        </matButiAlg>

        <flareEnhance>
            <flareEnhanceEnable> 1 </flareEnhanceEnable> <!-- 0:disable, 1 enable -->
            <degammaEnhanceEnable> 1 </degammaEnhanceEnable> <!-- 0:disable, 1 enable -->
            <degammaCoef> 1.5 </degammaCoef>
            <degammaQuantGain> 100 </degammaQuantGain>
            <erodeEnable> 1 </erodeEnable> <!-- 0:disable, 1 enable -->
        </flareEnhance>

        <pdSigmaCurve>
            <pdSigmaCurveParamK>11.0</pdSigmaCurveParamK>        <!--pddepth虚化曲线参数-->
            <pdSigmaCurveParamA>9.0</pdSigmaCurveParamA>        <!--pddepth虚化曲线参数-->
            <pdSigmaCurveParamD>0.15</pdSigmaCurveParamD>        <!--pddepth虚化曲线参数-->
            <pdSigmaCurveParamVbinA>2.8</pdSigmaCurveParamVbinA>
            <pdSigmaCurveParamVbinK>10.0</pdSigmaCurveParamVbinK>
        </pdSigmaCurve>

        <dualSigmaCurve>        <!--StereoDepth虚化曲线参数-->
            <slopF>1.4f</slopF>
            <slopFdecay>0.85f</slopFdecay>
            <slopBcoefA>-0.03f</slopBcoefA>
            <slopBcoefB>-0.3f</slopBcoefB>
            <slopBcoefC>1.8f</slopBcoefC>
            <slopBcoefD>2.40f</slopBcoefD>
            <dofK>0.016f</dofK>
            <dofB>0.083f</dofB>
        </dualSigmaCurve>
    </AlgorithmRFInfo>

    <ExternConfig>
        <packDispRefMatImg>0</packDispRefMatImg> <!-- 是否存储中间数据结果 dxo open, product close-->
    </ExternConfig>
</Config>
